
#include "PWM.h"

 long _freq = 0;
 char aux = 0;
 
void PWM_init(long freq)
{
        //Operation Mode = Fast PWM
        TCCR1A &=~ (1<<WGM10);
        TCCR1A |=  (1<<WGM11);
        TCCR1B |=  (1<<WGM12);
        TCCR1B |=  (1<<WGM13);
        
        //Compare value
        _freq = freq;
        //ICR1L = (F_CPU/1024/_freq) - 1;
        ICR1L = (F_CPU/1024/_freq) - 1;
        ICR1H |= ((F_CPU/1024/_freq) - 1)>>8;
}
void PWM_on()
{
        TCNT1L = 0x0000;
        //N = 1024
        TCCR1B |=  (1<<CS10);
        TCCR1B &=~ (1<<CS11);
        TCCR1B |=  (1<<CS12);
}

void PWM_off()
{
        //Clock setting T1clock = 0 Hz
        TCCR1B &=~ (1<<CS10);
        TCCR1B &=~ (1<<CS11);
        TCCR1B &=~ (1<<CS12);
}

void PWM_Write_duty(unsigned int duty, char channel, unsigned int resolution)
{    
     unsigned int reg=0;
      
      if(channel == 'A' ) {
        //Pin configuration
         DDRB |= (1<<DDB1);

        //Output active
        TCCR1A &=~ (1<<COM1A0);
        TCCR1A |=  (1<<COM1A1);
        
        reg = (((F_CPU/1024/_freq) - 1)*duty)/resolution;
        OCR1AL = reg;
        OCR1AH |= reg >>8;
        if((duty == resolution) && (aux==1)) PWM_off(), PORTB1_bit=1, aux=2;
        if(duty <resolution) aux=0;
        if(duty ==0) PWM_off(),  PORTB1_bit=0, aux=0;
        if((duty>0) && (aux==0)) PWM_on(), aux=1;
     }
     
     if(channel == 'B' ) {
         //Pin configuration
        DDRB |= (1<<DDB2);

        //Output active
        TCCR1A &=~ (1<<COM1B0);
        TCCR1A |=  (1<<COM1B1);
        
        reg = (((F_CPU/1024/_freq) - 1)*duty)/resolution;
        OCR1BL = reg;
        OCR1BH |= reg>>8;
        if((duty == resolution) && (aux==1)) PWM_off(), PORTB2_bit=1, aux=2;
        if(duty <resolution) aux=0;
        if(duty ==0) PWM_off(),  PORTB2_bit=0, aux=0;
        if((duty>0) && (aux==0)) PWM_on(), aux=1;
     }
}